#include <iostream>
#include "cgul_cxx.h"

using namespace std;

int main(int argc, char* argv[])
{
    int rv = 0;
    long int i = 0;

    try {

        cgul_vector_cxx v;

        for (i = 0 ; i < 1000 ; ++i) {
            v.push_back((void*)i);
        }

        while (v.get_size() > 0) {
            i = (long int)v.pop_back();
            cout << "i = " << i << endl;
        }

    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
