#include "cgul_cxx.h"

int main(int argc,
         char* argvp[])
{
    int rv = 0;
    size_t i = 0;
    size_t i_max = 0;
    cgul_wchar_t hello[] = {'h', 'e', 'l', 'l', 'o', 0};
    cgul_wchar_t hello2[24] = {0};
    cgul_wchar_t tests[] = {
        (cgul_wchar_t)'b',  (cgul_wchar_t)'a',  (cgul_wchar_t)'r',
        (cgul_wchar_t)' ',  (cgul_wchar_t)'\t', (cgul_wchar_t)'\n',
        (cgul_wchar_t)'\r', (cgul_wchar_t)'\f', (cgul_wchar_t)'\v',
        (cgul_wchar_t)'\0' /* sentinel */
    };

    try {

        cgul_wchar_cxx::wcscpy(hello2, hello);

        i_max = cgul_wchar_cxx::wcslen(hello2);
        for (i = 0 ; i < i_max ; ++i) {
            printf("hello2[%lu] = %c\n", (unsigned long)i , (char)hello2[i]);
        }

        /* Iterate over each test character. */
        for (i = 0 ; tests[i] ; ++i) {
            printf("%3d: %d\n",
                   tests[i],
                   cgul_wchar_cxx::isspace(tests[i]));
        }

    } catch (const cgul_exception_cxx& e) {
        fprintf(stderr, "*** Error: %s\n", e.get_message());
        rv = 1;
    }

    return rv;
}
