#ifndef CGUL_CXX_H
#define CGUL_CXX_H

/**
 * Convenience header to include all C++ wrappers for cgul.
 *
 * @file
 * @author Paul Serice
 * @brief convenience header to include all C++ wrappers for cgul
 */

#include "cgul.h"

#include "cgul_bdf_cxx.h"
#include "cgul_bdf_glyph_cxx.h"
#include "cgul_block_reader_cxx.h"
#include "cgul_block_reader_file_cxx.h"
#include "cgul_block_reader_memory_cxx.h"
#include "cgul_cache_cxx.h"
#include "cgul_char_cxx.h"
#include "cgul_convspec_cxx.h"
#include "cgul_crc16_cxx.h"
#include "cgul_crc16_incr_cxx.h"
#include "cgul_crc32_cxx.h"
#include "cgul_crc32_incr_cxx.h"
#include "cgul_crlf_cxx.h"
#include "cgul_crlf_file_cxx.h"
#include "cgul_csv_cxx.h"
#include "cgul_endian_cxx.h"
#include "cgul_event_router_cxx.h"
#include "cgul_exception_cxx.h"
#include "cgul_hash_cxx.h"
#include "cgul_hash_node_cxx.h"
#include "cgul_hchar_cxx.h"
#include "cgul_heap_cxx.h"
#include "cgul_heap_primitives_cxx.h"
#include "cgul_heap_sort_cxx.h"
#include "cgul_hstring_cxx.h"
#include "cgul_libc_cxx.h"
#include "cgul_line_wrapper_cxx.h"
#include "cgul_list_cxx.h"
#include "cgul_list_node_cxx.h"
#include "cgul_log2_cxx.h"
#include "cgul_merge_sort_cxx.h"
#include "cgul_microxml_cxx.h"
#include "cgul_mime_cxx.h"
#include "cgul_multimap_cxx.h"
#include "cgul_multimap_node_cxx.h"
#include "cgul_multiply64_cxx.h"
#include "cgul_progress_bar_cxx.h"
#include "cgul_radix_sort_cxx.h"
#include "cgul_random_cmwc32_cxx.h"
#include "cgul_random_lcg32_cxx.h"
#include "cgul_random_lfg32_cxx.h"
#include "cgul_random_mt32_cxx.h"
#include "cgul_random_well32_cxx.h"
#include "cgul_random_xorshift32_cxx.h"
#include "cgul_random_xorwow32_cxx.h"
#include "cgul_rbtree_cxx.h"
#include "cgul_rbtree_node_cxx.h"
#include "cgul_rolling_hash_cxx.h"
#include "cgul_shuffle_cxx.h"
#include "cgul_stanza_cxx.h"
#include "cgul_stream_reader_cxx.h"
#include "cgul_string_cxx.h"
#include "cgul_strtok_cxx.h"
#include "cgul_substring_cxx.h"
#include "cgul_trie_cxx.h"
#include "cgul_unicode_cxx.h"
#include "cgul_varsub_cxx.h"
#include "cgul_vector_cxx.h"
#include "cgul_wchar_cxx.h"
#include "cgul_wstring_cxx.h"

#endif  /*  CGUL_CXX_H  */
