#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

static void
doit3()
{
    cgul_exception_t local = NULL;
    //cgul_libc__set_out_of_memory(&local, 1);
    local = cgul_exception__new("Hello, World!");
    cgul_exception_cxx tmp = local;
    cgul_exception_cxx tmp2(tmp);
    throw cgul_exception_cxx(tmp2);
}

static void
doit2()
{
    doit3();
}

static void
doit()
{
    doit2();
}

int main(int argc, char* argv[])
{
    int rv = 0;

    try {
        doit();        
    } catch (const exception& sexception) {
        cerr << "*** Error: " << sexception.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& cexception) {
        cerr << "*** Error: " << cexception.get_message() << endl;
        rv = 1;
    }

    return rv;
}
